'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _parser = require('./util/parser');

var _parser2 = _interopRequireDefault(_parser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var REACT_IDENTIFIER = 'react';

exports.default = function (babel) {
  var t = babel.types;

  return {
    visitor: {
      Class: function Class(path, _ref) {
        var opts = _ref.opts;
        var node = path.node;

        if (!node || !node.superClass) return;
        _parser2.default.getSuperClassName(t, node);
      },
      ImportDeclaration: function ImportDeclaration(path, _ref2) {
        var opts = _ref2.opts;
        var node = path.node;

        if (!node) return;
        if (node.source.value === REACT_IDENTIFIER) {
          node.specifiers.forEach(function (specifier) {
            _parser2.default.getImportIdentifiers(t, specifier);
          });
        }
      },
      ExportDefaultDeclaration: function ExportDefaultDeclaration(path, _ref3) {
        var opts = _ref3.opts;
        var node = path.node;
        var lib = opts.lib;

        if (!node) return;
        var declaration = node.declaration;
        if (t.isCallExpression(declaration)) {
          path.traverse({
            CallExpression: function CallExpression(callpath) {
              callpath.traverse({
                Identifier: function Identifier(ipath) {
                  _parser2.default.changeExportExpression(t, lib, ipath, path);
                }
              });
            }
          });
        } else if (t.isClass(declaration)) {
          _parser2.default.getSuperClassName(t, declaration);
          _parser2.default.changeExportClass(t, lib, path);
        } else if (t.isIdentifier(declaration)) {
          _parser2.default.changeExportIdentifier(t, lib, path);
        }
      }
    }
  };
};